Index: src/station_gui.cpp
===================================================================
--- src/station_gui.cpp	(revision 13683)
+++ src/station_gui.cpp	(working copy)
@@ -25,6 +25,11 @@
 #include "gfx_func.h"
 #include "widgets/dropdown_func.h"
 #include "newgrf_cargo.h"
+#include "map_func.h"
+#include "settings_type.h"
+#include "tile_map.h"
+#include "station_map.h"
+#include "tilehighlight_func.h"
 #include "string_func.h"
 
 #include "table/strings.h"
@@ -613,14 +618,15 @@
 {      WWT_PANEL,     RESIZE_RB,    14,     0,   236,    14,    65, 0x0,               STR_NULL},                             // SVW_WAITING
 {  WWT_SCROLLBAR,    RESIZE_LRB,    14,   237,   248,    14,    65, 0x0,               STR_0190_SCROLL_BAR_SCROLLS_LIST},
 {      WWT_PANEL,    RESIZE_RTB,    14,     0,   248,    66,    97, 0x0,               STR_NULL},                             // SVW_ACCEPTLIST / SVW_RATINGLIST
-{ WWT_PUSHTXTBTN,     RESIZE_TB,    14,     0,    59,    98,   109, STR_00E4_LOCATION, STR_3053_CENTER_MAIN_VIEW_ON_STATION}, // SVW_LOCATION
-{ WWT_PUSHTXTBTN,     RESIZE_TB,    14,    60,   120,    98,   109, STR_3032_RATINGS,  STR_3054_SHOW_STATION_RATINGS},        // SVW_RATINGS / SVW_ACCEPTS
-{ WWT_PUSHTXTBTN,    RESIZE_RTB,    14,   121,   180,    98,   109, STR_0130_RENAME,   STR_3055_CHANGE_NAME_OF_STATION},      // SVW_RENAME
-{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   181,   194,    98,   109, STR_TRAIN,         STR_SCHEDULED_TRAINS_TIP },            // SVW_TRAINS
-{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   195,   208,    98,   109, STR_LORRY,         STR_SCHEDULED_ROAD_VEHICLES_TIP },     // SVW_ROADVEHS
-{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   209,   222,    98,   109, STR_PLANE,         STR_SCHEDULED_AIRCRAFT_TIP },          // SVW_PLANES
-{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   223,   236,    98,   109, STR_SHIP,          STR_SCHEDULED_SHIPS_TIP },             // SVW_SHIPS
-{  WWT_RESIZEBOX,   RESIZE_LRTB,    14,   237,   248,    98,   109, 0x0,               STR_RESIZE_BUTTON},
+{ WWT_PUSHTXTBTN,     RESIZE_TB,    14,     0,    59,   110,   121, STR_00E4_LOCATION, STR_3053_CENTER_MAIN_VIEW_ON_STATION}, // SVW_LOCATION
+{ WWT_PUSHTXTBTN,     RESIZE_TB,    14,    60,   120,   110,   121, STR_3032_RATINGS,  STR_3054_SHOW_STATION_RATINGS},        // SVW_RATINGS / SVW_ACCEPTS
+{ WWT_PUSHTXTBTN,    RESIZE_RTB,    14,   121,   180,   110,   121, STR_0130_RENAME,   STR_3055_CHANGE_NAME_OF_STATION},      // SVW_RENAME
+{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   181,   194,   110,   121, STR_TRAIN,         STR_SCHEDULED_TRAINS_TIP },            // SVW_TRAINS
+{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   195,   208,   110,   121, STR_LORRY,         STR_SCHEDULED_ROAD_VEHICLES_TIP },     // SVW_ROADVEHS
+{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   209,   222,   110,   121, STR_PLANE,         STR_SCHEDULED_AIRCRAFT_TIP },          // SVW_PLANES
+{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,   223,   236,   110,   121, STR_SHIP,          STR_SCHEDULED_SHIPS_TIP },             // SVW_SHIPS
+{  WWT_RESIZEBOX,   RESIZE_LRTB,    14,   237,   248,   110,   121, 0x0,               STR_RESIZE_BUTTON},
+{ WWT_PUSHTXTBTN,   RESIZE_LRTB,    14,     0,   248,    98,   109, STR_CLOSE_AIRPORT, STR_CLOSE_AIRPORT_TIP},                // SVW_CLOSEAIRPORT
 {   WIDGETS_END},
 };
 
@@ -758,6 +764,13 @@
 		this->SetWidgetDisabledState(SVW_ROADVEHS, !(st->facilities & FACIL_TRUCK_STOP) && !(st->facilities & FACIL_BUS_STOP));
 		this->SetWidgetDisabledState(SVW_PLANES,   !(st->facilities & FACIL_AIRPORT));
 		this->SetWidgetDisabledState(SVW_SHIPS,    !(st->facilities & FACIL_DOCK));
+		if (st->facilities & FACIL_AIRPORT) {
+			this->SetWidgetDisabledState(SVW_CLOSEAIRPORT, st->owner != _local_player);
+			this->SetWidgetLoweredState(SVW_CLOSEAIRPORT, HASBITS(st->airport_flags, AIRPORT_CLOSED_block));
+		} else {
+			this->DisableWidget(SVW_CLOSEAIRPORT);
+			this->RaiseWidget(SVW_CLOSEAIRPORT);
+		}
 
 		SetDParam(0, st->index);
 		SetDParam(1, st->facilities);
@@ -938,6 +951,12 @@
 				ShowVehicleListWindow(owner, VEH_SHIP, (StationID)this->window_number);
 				break;
 			}
+
+			case SVW_CLOSEAIRPORT: { // Open/close airport
+				const Station *st = GetStation(this->window_number);
+				DoCommandP(0, st->index, HASBITS(st->airport_flags, AIRPORT_CLOSED_block) ? 0 : 1, NULL, CMD_OPEN_CLOSE_AIRPORT | CMD_MSG(STR_CLOSE_AIRPORT_ERROR));
+				break;
+			}
 		}
 	}
 
@@ -959,7 +978,7 @@
 
 
 static const WindowDesc _station_view_desc = {
-	WDP_AUTO, WDP_AUTO, 249, 110, 249, 110,
+	WDP_AUTO, WDP_AUTO, 249, 122, 249, 122,
 	WC_STATION_VIEW, WC_NONE,
 	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET | WDF_UNCLICK_BUTTONS | WDF_STICKY_BUTTON | WDF_RESIZABLE,
 	_station_view_widgets,
@@ -974,3 +993,246 @@
 {
 	AllocateWindowDescFront<StationViewWindow>(&_station_view_desc, station);
 }
+
+static CommandContainer _selectStationCommand;
+static StationType _stationType;
+
+static void addStationID(StationID st)
+{
+	for (int i = 0; i < _stations_Nearby_Count; i++) {
+		if (_stations_Nearby_List[i] == st) return;
+	}
+
+	if ((_stations_Nearby_Count < sizeof(_stations_Nearby_List)/sizeof(_stations_Nearby_List[0])) &&
+			(GetStation(st)->owner == _current_player)) {
+		_stations_Nearby_List[_stations_Nearby_Count] = st;
+		_stations_Nearby_Count++;
+	}
+}
+
+// This doen't check wrapping!
+static bool InsideMap(TileIndex t)
+{
+	return (t < MapSize());
+}
+
+
+/**
+ * Do not laugh :)
+ * This approach (while not nice and correct) has some benefits:
+ * -stations appear nearly in order of distance
+ * -no sorting needed
+ * -no need to retrieve all stations within range, and discard the far away ones
+**/
+static Station* FindStationsNearby(TileIndex tile, int w, int h, bool distant_join)
+{
+	/* We start "above" supplied tile, then move in circles around w/h */
+	TileIndex tile_cur = tile;
+	int32 count;
+	int32 dist = 0;
+	int32 max_dist = distant_join ? _settings_game.station.station_spread : 1;
+
+	_stations_Nearby_Count = 0;
+
+	while (dist < max_dist) {
+		/* Move one up, one right */
+		tile_cur += TileDiffXY(-1, -1);
+
+		/* move down: */
+		count = h + (dist * 2) + 1;
+		while (count > 0) {
+			tile_cur += TileDiffXY(0, 1);
+
+			/* Check this tile for a station: */
+			if (InsideMap(tile_cur)) {
+				if (IsTileType(tile_cur, MP_STATION)) {
+					addStationID(GetStationIndex(tile_cur));
+				}
+			}
+			count--;
+		}
+		/* move left: */
+		count = w + (dist * 2) + 1;
+		while (count > 0) {
+			tile_cur += TileDiffXY(1, 0);
+
+			/* Check this tile for a station: */
+			if (InsideMap(tile_cur)) {
+				if (IsTileType(tile_cur, MP_STATION)) {
+					addStationID(GetStationIndex(tile_cur));
+				}
+			}
+			count--;
+		}
+		/* move up: */
+		count = h + (dist * 2) + 1;
+		while (count > 0) {
+			tile_cur += TileDiffXY(0, -1);
+
+			/* Check this tile for a station: */
+			if (InsideMap(tile_cur)) {
+				if (IsTileType(tile_cur, MP_STATION)) {
+					addStationID(GetStationIndex(tile_cur));
+				}
+			}
+			count--;
+		}
+		/* move right: */
+		count = w + (dist * 2) + 1;
+		while (count > 0) {
+			tile_cur += TileDiffXY(-1, 0);
+
+			/* Check this tile for a station: */
+			if (InsideMap(tile_cur)) {
+				if (IsTileType(tile_cur, MP_STATION)) {
+					addStationID(GetStationIndex(tile_cur));
+				}
+			}
+			count--;
+		}
+		dist++;
+	}
+
+	/* Now we check the inside, to return, if we sit on another station
+	 * correct: we need to check inside + 1 around.
+	 */
+	{
+		int x;
+		int y;
+		Station *st = NULL;
+		tile_cur = tile;
+		for (y = 0; y < h; y++) {
+			for (x = 0; x < w; x++) {
+				if (InsideMap(tile_cur)) {
+					if (IsTileType(tile_cur, MP_STATION)) {
+						st = GetStationByTile(tile_cur);
+					}
+				}
+				tile_cur += TileDiffXY(1, 0);
+			}
+			tile_cur += TileDiffXY(-w, 1);
+		}
+		/* Empty list, if ontop of another station */
+		if (st != NULL) _stations_Nearby_Count = 0;
+		return st;
+	}
+}
+
+enum JoinStationWidgets {
+	JSW_WIDGET_CLOSEBOX = 0,
+	JSW_WIDGET_CAPTION,
+	JSW_PANEL,
+};
+
+static const Widget _select_station_widgets[] = {
+{   WWT_CLOSEBOX,   RESIZE_NONE,    7,     0,    10,     0,    13, STR_00C5,                        STR_018B_CLOSE_WINDOW},
+{    WWT_CAPTION,   RESIZE_NONE,    7,    11,   199,     0,    13, STR_SELECT_STATION_TO_JOIN,      STR_018C_WINDOW_TITLE_DRAG_THIS},
+{      WWT_PANEL,   RESIZE_NONE,    7,     0,   199,    14,   179, 0x0,                             STR_NULL},
+
+{   WIDGETS_END},
+};
+
+struct SelectStationWindow : Window {
+	SelectStationWindow(const WindowDesc *desc, WindowNumber window_number = 0) : Window(desc, window_number)
+	{
+		FindStationsNearby(TileVirtXY(_thd.pos.x, _thd.pos.y), _thd.size.x / TILE_SIZE, _thd.size.y / TILE_SIZE, true);
+	}
+
+	~SelectStationWindow()
+	{
+		_thd.lockPos = false;
+		_thd.lockSize = false;
+	}
+
+	virtual void OnPaint()
+	{
+		int y = 17;
+		int i = 0;
+		Station *st;
+
+		this->DrawWidgets();
+
+		DrawString(3, y, STR_CREATE_SPLITTED_STATION, 0);
+		y+= 10;
+		while (i < _stations_Nearby_Count) {
+			st = GetStation(_stations_Nearby_List[i]);
+			SetDParam(0, st->index);
+			SetDParam(1, st->facilities);
+			DrawString(3, y, STR_3049_0, 0);
+
+			i++;
+			y+= 10;
+		}
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		if (widget == JSW_PANEL) {
+			uint32 st_index = (pt.y - 16) / 10;
+			bool distant_join = (st_index > 0);
+			if (distant_join) st_index--;
+			if ((st_index < _stations_Nearby_Count) || (!distant_join)) {
+
+				/* Insert station to be joined into stored command */
+				SB(_selectStationCommand.p2, 16, 16,
+					(distant_join ? _stations_Nearby_List[st_index] : INVALID_STATION));
+
+				/* Execute stored Command */
+				DoCommandP(_selectStationCommand.tile,
+					_selectStationCommand.p1, _selectStationCommand.p2,
+					_selectStationCommand.callback, _selectStationCommand.cmd);
+
+				/* Close Window. */
+				//this->~SelectStationWindow();
+			}
+		}
+	}
+
+	virtual void OnTick()
+	{
+		if (_thd.dirty & 2) {
+			_thd.dirty &= ~2;
+			this->SetDirty();
+		}
+	}
+};
+
+static const WindowDesc _select_station_desc = {
+	WDP_AUTO, WDP_AUTO, 200, 180, 200, 180,
+	WC_SELECT_STATION, WC_NONE,
+	WDF_STD_TOOLTIPS | WDF_STD_BTN | WDF_DEF_WIDGET,
+	_select_station_widgets,
+};
+
+void ShowSelectStation(CommandContainer cmd, StationType stationType, bool lockPos, bool lockSize)
+{
+	Window *w = FindWindowById(WC_SELECT_STATION, 0);
+	if (w == NULL) {
+		_thd.lockPos = lockPos;
+		_thd.lockSize = lockSize;
+		_selectStationCommand = cmd;
+		_stationType = stationType;
+		// AllocateWindowDesc(&_select_station_desc);
+		new SelectStationWindow(&_select_station_desc);
+	}
+}
+
+bool StationJoinerNeeded(TileIndex tile, int w, int h)
+{
+	/* If a window is already opened, we always return true */
+	Window *window = FindWindowById(WC_SELECT_STATION, 0);
+	if (window != NULL) return true;
+
+	/* only show the popup, if we press ctrl */
+	if (!_ctrl_pressed) return false;
+
+	/* Test if a station joiner is needed: */
+	FindStationsNearby(tile, w, h, false);
+	int neighbourStationCount = _stations_Nearby_Count;
+	Station *st = FindStationsNearby(tile, w, h, true);
+	if (_settings_game.station.adjacent_stations) {
+		return (neighbourStationCount == 0 || _stations_Nearby_Count > 1) && (st == NULL);
+	} else {
+		return (neighbourStationCount == 0) && (_stations_Nearby_Count > 0) && (st == NULL);
+	}
+}
Index: src/airport.h
===================================================================
--- src/airport.h	(revision 13683)
+++ src/airport.h	(working copy)
@@ -113,8 +113,10 @@
 	OUT_WAY_block2           = 1ULL << 31,
 /* end of new blocks */
 
-	NOTHING_block            = 1ULL << 30;
+	NOTHING_block            = 1ULL << 30,
 
+	AIRPORT_CLOSED_block     = 1ULL << 32;
+
 struct AirportMovingData {
 	int16 x;
 	int16 y;
Index: src/order_gui.cpp
===================================================================
--- src/order_gui.cpp	(revision 13683)
+++ src/order_gui.cpp	(working copy)
@@ -31,6 +31,7 @@
 #include "string_func.h"
 #include "depot_base.h"
 #include "tilehighlight_func.h"
+#include "sharedinfrastructure.h"
 
 #include "table/sprites.h"
 #include "table/strings.h"
@@ -271,7 +272,7 @@
 	if (_settings_game.order.gotodepot) {
 		switch (GetTileType(tile)) {
 			case MP_RAILWAY:
-				if (v->type == VEH_TRAIN && IsTileOwner(tile, _local_player)) {
+ 				if (v->type == VEH_TRAIN && (IsTileOwner(tile, _local_player) || SharedRailwayDepots(tile, _local_player))) {
 					if (IsRailDepot(tile)) {
 						order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
 						if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
@@ -281,7 +282,7 @@
 				break;
 
 			case MP_ROAD:
-				if (IsRoadDepot(tile) && v->type == VEH_ROAD && IsTileOwner(tile, _local_player)) {
+				if (IsRoadDepot(tile) && v->type == VEH_ROAD && (IsTileOwner(tile, _local_player) || SharedRoadDepots(tile, _local_player))) {
 					order.MakeGoToDepot(GetDepotByTile(tile)->index, ODTFB_PART_OF_ORDERS);
 					if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
 					return order;
@@ -290,7 +291,7 @@
 
 			case MP_STATION:
 				if (v->type != VEH_AIRCRAFT) break;
-				if (IsHangar(tile) && IsTileOwner(tile, _local_player)) {
+				if (IsHangar(tile) && (IsTileOwner(tile, _local_player) || SharedAirports(tile, _local_player))) {
 					order.MakeGoToDepot(GetStationIndex(tile), ODTFB_PART_OF_ORDERS);
 					return order;
 				}
@@ -298,9 +299,8 @@
 
 			case MP_WATER:
 				if (v->type != VEH_SHIP) break;
-				if (IsShipDepot(tile) && IsTileOwner(tile, _local_player)) {
+				if (IsShipDepot(tile) && (IsTileOwner(tile, _local_player)||SharedWaterDepots(tile, _local_player))) {
 					TileIndex tile2 = GetOtherShipDepotTile(tile);
-
 					order.MakeGoToDepot(GetDepotByTile(tile < tile2 ? tile : tile2)->index, ODTFB_PART_OF_ORDERS);
 					return order;
 				}
@@ -313,7 +313,7 @@
 	/* check waypoint */
 	if (IsTileType(tile, MP_RAILWAY) &&
 			v->type == VEH_TRAIN &&
-			IsTileOwner(tile, _local_player) &&
+			(IsTileOwner(tile, _local_player)||SharedTracks(tile, _local_player)) &&
 			IsRailWaypoint(tile)) {
 		order.MakeGoToWaypoint(GetWaypointByTile(tile)->index);
 		if (_settings_client.gui.new_nonstop) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
@@ -324,19 +324,23 @@
 		StationID st_index = GetStationIndex(tile);
 		const Station *st = GetStation(st_index);
 
-		if (st->owner == _current_player || st->owner == OWNER_NONE) {
 			byte facil;
 			(facil = FACIL_DOCK, v->type == VEH_SHIP) ||
 			(facil = FACIL_TRAIN, v->type == VEH_TRAIN) ||
 			(facil = FACIL_AIRPORT, v->type == VEH_AIRCRAFT) ||
 			(facil = FACIL_BUS_STOP, v->type == VEH_ROAD && IsCargoInClass(v->cargo_type, CC_PASSENGERS)) ||
 			(facil = FACIL_TRUCK_STOP, 1);
-			if (st->facilities & facil) {
-				order.MakeGoToStation(st_index);
-				if (_settings_client.gui.new_nonstop && (v->type == VEH_TRAIN || v->type == VEH_ROAD)) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
-				return order;
+			if(((facil==FACIL_DOCK) && ((st->owner == _current_player) || SharedHarbours(tile, _current_player))) ||
+  			   ((facil==FACIL_TRAIN) && ((st->owner == _current_player) || SharedRailwayStations(tile, _current_player))) ||
+  			   ((facil==FACIL_AIRPORT) && ((st->owner == _current_player) || SharedAirports(tile, _current_player))) ||
+  			   (((facil==FACIL_BUS_STOP)||(facil==FACIL_TRUCK_STOP)) && ((st->owner == _current_player) || SharedRoadStops(tile, _current_player)))) {
+  					if (st->facilities & facil) {
+  						order.MakeGoToStation(st_index);
+						if (_ctrl_pressed) order.SetLoadType(OLFB_FULL_LOAD);
+  						if (_settings_client.gui.new_nonstop && (v->type == VEH_TRAIN || v->type == VEH_ROAD)) order.SetNonStopType(ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS);
+  						return order;
+  					}
 			}
-		}
 	}
 
 	/* not found */
@@ -604,6 +608,25 @@
 		this->resize.step_height = 10;
 		this->selected_order = -1;
 		this->vehicle = v;
+
+		if (_settings_client.gui.quick_goto) {
+			/*
+			 *  on order window popup:
+			 *  if only 1 or 2 station order entries -> goto button is active
+			 */
+
+			int n_st = 0;
+			const Order *order;
+			FOR_VEHICLE_ORDERS(v, order) {
+				if (order->IsType(OT_GOTO_STATION)) {
+					n_st++;
+				}
+			}
+			if (n_st < 2) {
+				OrderClick_Goto(this, 0);
+			}
+		}
+
 		if (_settings_game.order.timetabling) {
 			this->widget[ORDER_WIDGET_CAPTION].right -= 61;
 		} else {
@@ -984,7 +1007,8 @@
 
 			if (DoCommandP(this->vehicle->tile, this->vehicle->index + (this->OrderGetSel() << 16), cmd.Pack(), NULL, CMD_INSERT_ORDER | CMD_MSG(STR_8833_CAN_T_INSERT_NEW_ORDER))) {
 				if (this->selected_order != -1) this->selected_order++;
-				ResetObjectToPlace();
+				/* quickgoto: GoTo button stays active */
+				if (!_settings_client.gui.quick_goto) ResetObjectToPlace();
 			}
 		}
 	}
Index: src/cargopacket.h
===================================================================
--- src/cargopacket.h	(revision 13683)
+++ src/cargopacket.h	(working copy)
@@ -7,6 +7,7 @@
 
 #include "oldpool.h"
 #include "economy_type.h"
+#include "player_type.h"
 #include "tile_type.h"
 #include "station_type.h"
 #include <list>
@@ -24,7 +25,7 @@
  * Container for cargo from the same location and time
  */
 struct CargoPacket : PoolItem<CargoPacket, CargoPacketID, &_CargoPacket_pool> {
-	Money feeder_share;     ///< Value of feeder pickup to be paid for on delivery of cargo
+	Money feeder_share[MAX_PLAYERS];     ///< Value of feeder pickup to be paid for on delivery of cargo
 	TileIndex source_xy;    ///< The origin of the cargo (first station in feeder chain)
 	TileIndex loaded_at_xy; ///< Location where this cargo has been loaded into the vehicle
 	StationID source;       ///< The station where the cargo came from first
Index: src/water_cmd.cpp
===================================================================
--- src/water_cmd.cpp	(revision 13683)
+++ src/water_cmd.cpp	(working copy)
@@ -344,7 +344,7 @@
  * @param tile end tile of stretch-dragging
  * @param flags type of operation
  * @param p1 start tile of stretch-dragging
- * @param p2 specifies canal (0), water (1) or river (2); last two can only be built in scenario editor
+ * @param p2 specifies canal (0), water (1) or river (2); water can only be built in scenario editor
  */
 CommandCost CmdBuildCanal(TileIndex tile, uint32 flags, uint32 p1, uint32 p2)
 {
@@ -356,8 +356,8 @@
 
 	if (p1 >= MapSize()) return CMD_ERROR;
 
-	/* Outside of the editor you can only build canals, not oceans */
-	if (p2 != 0 && _game_mode != GM_EDITOR) return CMD_ERROR;
+	/* Outside of the editor you may not build oceans */
+	if (p2 == 1 && _game_mode != GM_EDITOR) return CMD_ERROR;
 
 	x = TileX(tile);
 	y = TileY(tile);
@@ -380,8 +380,8 @@
 			return_cmd_error(STR_0007_FLAT_LAND_REQUIRED);
 		}
 
-		/* can't make water of water! */
-		if (IsTileType(tile, MP_WATER) && (!IsTileOwner(tile, OWNER_WATER) || p2 == 1)) continue;
+		/* skip tile if it already has the right type */
+		if (IsTileType(tile, MP_WATER) && (p2 == 1 && IsSea(tile) || (p2 == 0 && IsCanal(tile)) || (p2 == 2 && IsRiver(tile)))) continue;
 
 		ret = DoCommand(tile, 0, 0, flags, CMD_LANDSCAPE_CLEAR);
 		if (CmdFailed(ret)) return ret;
@@ -400,6 +400,7 @@
 		}
 
 		cost.AddCost(_price.clear_water);
+		if (p2 == 2) cost.AddCost(_price.clear_water * 3);
 	} END_TILE_LOOP(tile, size_x, size_y, 0);
 
 	if (cost.GetCost() == 0) {
Index: src/economy.cpp
===================================================================
--- src/economy.cpp	(revision 13683)
+++ src/economy.cpp	(working copy)
@@ -45,6 +45,7 @@
 #include "gfx_func.h"
 #include "autoreplace_func.h"
 #include "player_gui.h"
+#include "sharedinfrastructure.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -383,6 +384,8 @@
 					DeleteWindowById(WC_VEHICLE_VIEW, v->index);
 					DeleteWindowById(WC_VEHICLE_DETAILS, v->index);
 					DeleteWindowById(WC_VEHICLE_ORDERS, v->index);
+					/* clean shared infrastructure */
+					UpdateSharedOnRemove(v->index);
 
 					if (v->IsPrimaryVehicle() || (v->type == VEH_TRAIN && IsFreeWagon(v))) {
 						switch (v->type) {
@@ -392,7 +395,11 @@
 								Vehicle *u = v;
 								do {
 									Vehicle *next = GetNextVehicle(u);
+									TileIndex old_tile = v->tile;
+									DiagDirection old_dir = DirToDiagDir(v->direction);
 									delete u;
+									/* now that vehicle is removed, clear signal */
+									UpdateSignalsOnSegment(old_tile, old_dir, GetTileOwner(old_tile));
 									u = next;
 								} while (u != NULL);
 							} break;
@@ -423,6 +430,12 @@
 			}
 		}
 	}
+	
+	/** take care of other players vehicles on bankrupt company's shared structure
+	 * at this point, there should be no vehicle left to old_player */
+	if (new_player == PLAYER_SPECTATOR) {
+		OnSharedClose(old_player, SHARED_ALL);
+	}
 
 	/*  Change ownership of tiles */
 	{
@@ -1362,8 +1375,10 @@
 	int result = 0;
 
 	Money vehicle_profit = 0; // Money paid to the train
-	Money route_profit   = 0; // The grand total amount for the route. A-D of transfer chain A-B-C-D
+	Money route_profit[MAX_PLAYERS] = {0};  // The grand total amount for the route. A-D of transfer chain A-B-C-D
+	bool route_profit_change = false;
 	Money virtual_profit = 0; // The virtual profit for entire vehicle chain
+	const Player* p;
 
 	StationID last_visited = front_v->last_station_visited;
 	Station *st = GetStation(last_visited);
@@ -1403,8 +1418,13 @@
 				/* handle end of route payment */
 				Money profit = DeliverGoods(cp->count, v->cargo_type, cp->source, last_visited, cp->source_xy, cp->days_in_transit);
 				cp->paid_for = true;
-				route_profit   += profit; // display amount paid for final route delivery, A-D of a chain A-B-C-D
-				vehicle_profit += profit - cp->feeder_share;                    // whole vehicle is not payed for transfers picked up earlier
+				FOR_ALL_PLAYERS(p) {   // display amount paid for final route delivery, A-D of a chain A-B-C-D
+					route_profit[p->index] += cp->feeder_share[p->index];
+					profit -= cp->feeder_share[p->index]; // whole vehicle is not payed for transfers picked up earlier
+				}
+				route_profit[v->owner] += profit;
+				vehicle_profit += profit;
+				route_profit_change = true;
 
 				result |= 1;
 
@@ -1420,7 +1440,7 @@
 
 					front_v->profit_this_year += profit << 8;
 					virtual_profit   += profit; // accumulate transfer profits for whole vehicle
-					cp->feeder_share += profit; // account for the (virtual) profit already made for the cargo packet
+					cp->feeder_share[front_v->owner] += profit; // account for the (virtual) profit already made for the cargo packet
 					cp->paid_for      = true;   // record that the cargo has been paid for to eliminate double counting
 				}
 				result |= 2;
@@ -1435,9 +1455,13 @@
 		ShowFeederIncomeAnimation(front_v->x_pos, front_v->y_pos, front_v->z_pos, virtual_profit);
 	}
 
-	if (route_profit != 0) {
+	if (route_profit_change) {
 		front_v->profit_this_year += vehicle_profit << 8;
-		SubtractMoneyFromPlayer(CommandCost(front_v->GetExpenseType(true), -route_profit));
+		FOR_ALL_PLAYERS(p) {
+			_current_player = p->index;
+			SubtractMoneyFromPlayer(CommandCost(front_v->GetExpenseType(true), -route_profit[p->index]));
+		}
+		_current_player = front_v->owner;
 
 		if (IsLocalPlayer() && !PlayVehicleSound(front_v, VSE_LOAD_UNLOAD)) {
 			SndPlayVehicleFx(SND_14_CASHTILL, front_v);
Index: src/variables.h
===================================================================
--- src/variables.h	(revision 13683)
+++ src/variables.h	(working copy)
@@ -69,6 +69,10 @@
 /* landscape.cpp */
 extern const byte _tileh_to_sprite[32];
 
+/* station_gui.c */
+VARDEF uint16 _stations_Nearby_List[15];
+VARDEF uint8 _stations_Nearby_Count;
+
 /* misc */
 VARDEF char _screenshot_name[128];
 VARDEF byte _vehicle_design_names;
Index: src/news_gui.cpp
===================================================================
--- src/news_gui.cpp	(revision 13683)
+++ src/news_gui.cpp	(working copy)
@@ -133,6 +133,7 @@
 	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_NONE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_BANKRUPT
 	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_TILE,                DrawNewsBankrupcy       }, ///< NS_COMPANY_NEW
 	{ NT_OPENCLOSE,       NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_OPENCLOSE
+	{ NT_COMPANY_INFO,    NM_NORMAL,   NF_VIEWPORT | NF_TILE,  NULL                    }, ///< NS_COMPANY_SHARING
 	{ NT_ECONOMY,         NM_NORMAL,   NF_NONE,                NULL                    }, ///< NS_ECONOMY
 	{ NT_INDUSTRY_PLAYER, NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_PLAYER
 	{ NT_INDUSTRY_OTHER,  NM_THIN,     NF_VIEWPORT|NF_TILE,    NULL                    }, ///< NS_INDUSTRY_OTHER
Index: src/vehicle_gui.cpp
===================================================================
--- src/vehicle_gui.cpp	(revision 13683)
+++ src/vehicle_gui.cpp	(working copy)
@@ -1844,16 +1844,17 @@
 		const Vehicle *v = GetVehicle(this->window_number);
 		StringID str;
 		bool is_localplayer = v->owner == _local_player;
+		TileIndex tile = v->tile;
+		bool is_trackowner  = IsTileOwner(tile,_local_player);
 		bool refitable_and_stopped_in_depot = IsVehicleRefitable(v);
 
 		this->SetWidgetDisabledState(VVW_WIDGET_GOTO_DEPOT, !is_localplayer);
-		this->SetWidgetDisabledState(VVW_WIDGET_REFIT_VEH,
-																!refitable_and_stopped_in_depot || !is_localplayer);
+		this->SetWidgetDisabledState(VVW_WIDGET_REFIT_VEH, !refitable_and_stopped_in_depot || !is_localplayer);
 		this->SetWidgetDisabledState(VVW_WIDGET_CLONE_VEH, !is_localplayer);
 
 		if (v->type == VEH_TRAIN) {
-			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_localplayer);
-			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_localplayer);
+			this->SetWidgetDisabledState(VVW_WIDGET_FORCE_PROCEED, !is_trackowner);
+			this->SetWidgetDisabledState(VVW_WIDGET_TURN_AROUND, !is_trackowner);
 
 			/* Cargo refit button is disabled, until we know we can enable it below. */
 
Index: src/cargopacket.cpp
===================================================================
--- src/cargopacket.cpp	(revision 13683)
+++ src/cargopacket.cpp	(working copy)
@@ -8,6 +8,7 @@
 #include "cargopacket.h"
 #include "saveload.h"
 #include "oldpool_func.h"
+#include "player_base.h"
 
 /* Initialize the cargopacket-pool */
 DEFINE_OLD_POOL_GENERIC(CargoPacket, CargoPacket)
@@ -21,6 +22,8 @@
 
 CargoPacket::CargoPacket(StationID source, uint16 count)
 {
+	const Player* p;
+
 	if (source != INVALID_STATION) assert(count != 0);
 
 	this->source          = source;
@@ -29,7 +32,8 @@
 
 	this->count           = count;
 	this->days_in_transit = 0;
-	this->feeder_share    = 0;
+	FOR_ALL_PLAYERS(p)
+		this->feeder_share[p->index]= 0;
 	this->paid_for        = false;
 }
 
@@ -49,7 +53,8 @@
 	SLE_VAR(CargoPacket, loaded_at_xy,    SLE_UINT32),
 	SLE_VAR(CargoPacket, count,           SLE_UINT16),
 	SLE_VAR(CargoPacket, days_in_transit, SLE_UINT8),
-	SLE_VAR(CargoPacket, feeder_share,    SLE_INT64),
+	SLE_CONDVAR(CargoPacket, feeder_share[0], SLE_INT64, 0, SL_VERSION_PATCH),
+	SLE_CONDARR(CargoPacket, feeder_share,    SLE_INT64, MAX_PLAYERS, SL_VERSION_PATCH, SL_MAX_VERSION),
 	SLE_VAR(CargoPacket, paid_for,        SLE_BOOL),
 
 	SLE_END()
@@ -142,13 +147,16 @@
 
 void CargoList::Append(CargoPacket *cp)
 {
+	const Player* p;
+
 	assert(cp != NULL);
 	assert(cp->IsValid());
 
 	for (List::iterator it = packets.begin(); it != packets.end(); it++) {
 		if ((*it)->SameSource(cp) && (*it)->count + cp->count <= 65535) {
 			(*it)->count        += cp->count;
-			(*it)->feeder_share += cp->feeder_share;
+			FOR_ALL_PLAYERS(p)
+				(*it)->feeder_share[p->index] += cp->feeder_share[p->index];
 			delete cp;
 
 			InvalidateCache();
@@ -189,6 +197,7 @@
 {
 	assert(mta == MTA_FINAL_DELIVERY || dest != NULL);
 	CargoList tmp;
+	const Player* p;
 
 	while (!packets.empty() && count > 0) {
 		CargoPacket *cp = *packets.begin();
@@ -223,14 +232,16 @@
 				cp_new->loaded_at_xy    = (mta == MTA_CARGO_LOAD) ? data : cp->loaded_at_xy;
 
 				cp_new->days_in_transit = cp->days_in_transit;
-				cp_new->feeder_share    = cp->feeder_share / count;
+				FOR_ALL_PLAYERS(p)
+					cp_new->feeder_share[p->index] = cp->feeder_share[p->index] / count;
 				/* When cargo is moved into another vehicle you have *always* paid for it */
 				cp_new->paid_for        = (mta == MTA_CARGO_LOAD) ? false : cp->paid_for;
 
 				cp_new->count = count;
 				dest->packets.push_back(cp_new);
 
-				cp->feeder_share /= cp->count - count;
+				FOR_ALL_PLAYERS(p)
+					cp->feeder_share[p->index] /= cp->count - count;
 			}
 			cp->count -= count;
 
@@ -260,6 +271,7 @@
 	feeder_share = 0;
 	source = INVALID_STATION;
 	days_in_transit = 0;
+	const Player* p;
 
 	if (empty) return;
 
@@ -268,7 +280,8 @@
 		count        += (*it)->count;
 		unpaid_cargo |= !(*it)->paid_for;
 		dit          += (*it)->days_in_transit * (*it)->count;
-		feeder_share += (*it)->feeder_share;
+		FOR_ALL_PLAYERS(p)
+			feeder_share += (*it)->feeder_share[p->index];
 	}
 	days_in_transit = dit / count;
 	source = (*packets.begin())->source;
Index: src/gui.h
===================================================================
--- src/gui.h	(revision 13683)
+++ src/gui.h	(working copy)
@@ -61,7 +61,7 @@
 void ShowErrorMessage(StringID msg_1, StringID msg_2, int x, int y);
 
 void ShowSmallMap();
-void ShowExtraViewPortWindow(TileIndex tile = INVALID_TILE);
+int ShowExtraViewPortWindow(TileIndex tile = INVALID_TILE);
 
 void BuildFileList();
 void SetFiosType(const byte fiostype);
Index: src/newgrf_station.cpp
===================================================================
--- src/newgrf_station.cpp	(revision 13683)
+++ src/newgrf_station.cpp	(working copy)
@@ -827,7 +827,7 @@
 }
 
 
-static const StationSpec* GetStationSpec(TileIndex t)
+const StationSpec* GetStationSpec(TileIndex t)
 {
 	const Station* st;
 	uint specindex;
Index: src/pathfind.cpp
===================================================================
--- src/pathfind.cpp	(revision 13683)
+++ src/pathfind.cpp	(working copy)
@@ -17,6 +17,7 @@
 #include "core/random_func.hpp"
 #include "core/alloc_type.hpp"
 #include "tunnelbridge.h"
+#include "sharedinfrastructure.h"
 
 /* remember which tiles we have already visited so we don't visit them again. */
 static bool TPFSetTileBit(TrackPathFinder *tpf, TileIndex tile, int dir)
Index: src/rev.cpp.in
===================================================================
--- src/rev.cpp.in	(revision 13683)
+++ src/rev.cpp.in	(working copy)
@@ -20,7 +20,7 @@
  * norev000 is for non-releases that are made on systems without
  * subversion or sources that are not a checkout of subversion.
  */
-const char _openttd_revision[] = "@@VERSION@@";
+const char _openttd_revision[] = "r13683-wwottdgd2";
 
 /**
  * Let us know if current build was modified. This detection
Index: src/network/network_type.h
===================================================================
--- src/network/network_type.h	(revision 13683)
+++ src/network/network_type.h	(working copy)
@@ -18,7 +18,7 @@
 	 *  players that can really play.. so.. a max of 4 spectators.. gives us..
 	 *  MAX_PLAYERS + 3
 	 */
-	MAX_CLIENTS = MAX_PLAYERS + 3,
+	MAX_CLIENTS = MAX_PLAYERS + 47,
 
 	/** Do not change this next line. It should _ALWAYS_ be MAX_CLIENTS + 1 */
 	MAX_CLIENT_INFO = MAX_CLIENTS + 1,
@@ -57,6 +57,7 @@
 	uint32 client_ip;                               ///< IP-address of the client (so he can be banned)
 	Date join_date;                                 ///< Gamedate the player has joined
 	char unique_id[NETWORK_UNIQUE_ID_LENGTH];       ///< Every play sends an unique id so we can indentify him
+	byte mute;                                       ///< Contains the mute status
 };
 
 enum NetworkPasswordType {
